Loading...
Searching...
No Matches
casacore::FuncExprData Class Reference
Functionals_module_internal_classes

More...

`#include <FuncExprData.h>`

## Classes

struct | ExprCompState
| The compilation state descriptor. More...
struct | ExprOperator
| The operator description: code; priority; # of arguments; # of arguments used up (or produced for functions). More...

## Public Types

enum

opTypes {
NOP ,
UNAMIN ,
UNAPLUS ,
NON ,
POW ,
GTE ,
LTE ,
EQ ,
NEQ ,
OR ,
AND ,
CONDEX ,
CONDEX2 ,
CONDEX3 ,
ADD ,
SUB ,
MUL ,
DIV ,
LT ,
GT ,
CONST ,
PARAM ,
ARG ,
TOIMAG ,
LBRACE ,
RBRACE ,
LPAREN ,
RPAREN ,
LBR ,
RBR ,
COMMA ,
FINISH ,
GOTO ,
GOTOF ,
GOTOT ,
SIN ,
COS ,
ATAN ,
ATAN2 ,
ASIN ,
ACOS ,
EXP ,
EXP10 ,
EXP2 ,
LOG ,
LOG10 ,
LOG2 ,
ERF ,
ERFC ,
PI ,
EE ,
ABS ,
FLOOR ,
CEIL ,
ROUND ,
INT ,
FRACT ,
SQRT ,
COMPLEX ,
REAL ,
IMAG ,
AMPL ,
PHASE ,
NopTypes
}

| Operations. More...
enum | opCategories { UNA2 , UNA1 , BIN2 , BIN1 , SPEC , FUNC , NopCategories }
| Operation category. More...
enum | specAction { NONE , SAVENV , GOTOPC , FINAL }
| Special categories. More...
enum | specPriority { RTLPRI , SPCPRI , FINPRI }
| Special priority levels. More...

## Public Member Functions

| FuncExprData ()
| Construct the data for the expression analysis.
| ~FuncExprData ()
| Destructor.
map< String, ExprOperator > & | unary2 ()
| Accessors of the various maps.
const map< String, ExprOperator > & | unary2 () const
map< String, ExprOperator > & | unary1 ()
const map< String, ExprOperator > & | unary1 () const
map< String, ExprOperator > & | binary2 ()
const map< String, ExprOperator > & | binary2 () const
map< String, ExprOperator > & | binary1 ()
const map< String, ExprOperator > & | binary1 () const
map< String, ExprOperator > & | special ()
const map< String, ExprOperator > & | special () const
map< String, ExprOperator > & | function ()
const map< String, ExprOperator > & | function () const
void | print (ostream &os, const map< String, FuncExprData::ExprOperator > &m) const
| Print an operator map.
void | print (ostream &os, const FuncExprData::ExprOperator &pos) const
| Print an operation.

## Private Attributes

map< String, ExprOperator > | una2_p
| Unary operators of 2 characters.
map< String, ExprOperator > | una1_p
| Unary operators of 1 character.
map< String, ExprOperator > | bin2_p
| Binary operators of 2 characters.
map< String, ExprOperator > | bin1_p
| Binary operators of 1 character.
map< String, ExprOperator > | spop_p
| Special operators.
map< String, ExprOperator > | func_p
| Function names.
map< opTypes, ExprOperator > | allop_p
| All operators.

## Detailed Description

Data and enumerations for functional expressions

### Intended use:

Internal

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Prerequisite

- Function class

### Synopsis

This class provides enumerations for expression analysis; and data element descriptions

### Example

### Motivation

To tie the Glish language to non-linear fitting procedures

### Thrown Exceptions

### To Do

- nothing directly

Definition at line 71 of file FuncExprData.h.

## Member Enumeration Documentation

## opCategories

enum casacore::FuncExprData::opCategories

Operation category.

Enumerator
UNA2 | Unary, binary 1 or 2 character.
UNA1 |
BIN2 |
BIN1 |
SPEC | Special and functions.
FUNC |
NopCategories | Number.

Definition at line 143 of file FuncExprData.h.

## opTypes

enum casacore::FuncExprData::opTypes

Operations.

Enumerator
NOP |
UNAMIN |
UNAPLUS |
NON |
POW |
GTE |
LTE |
EQ |
NEQ |
OR |
AND |
CONDEX |
CONDEX2 |
CONDEX3 |
ADD |
SUB |
MUL |
DIV |
LT |
GT |
CONST |
PARAM |
ARG |
TOIMAG |
LBRACE |
RBRACE |
LPAREN |
RPAREN |
LBR |
RBR |
COMMA |
FINISH |
GOTO |
GOTOF |
GOTOT |
SIN |
COS |
ATAN |
ATAN2 |
ASIN |
ACOS |
EXP |
EXP10 |
EXP2 |
LOG |
LOG10 |
LOG2 |
ERF |
ERFC |
PI |
EE |
ABS |
FLOOR |
CEIL |
ROUND |
INT |
FRACT |
SQRT |
COMPLEX |
REAL |
IMAG |
AMPL |
PHASE |
NopTypes | Number.

Definition at line 75 of file FuncExprData.h.

## specAction

enum casacore::FuncExprData::specAction

Special categories.

Enumerator
NONE |
SAVENV | Save environment while compiling.
GOTOPC | Indicate a GOTO.
FINAL | Final expression codes.

Definition at line 151 of file FuncExprData.h.

## specPriority

enum casacore::FuncExprData::specPriority

Special priority levels.

Enumerator
RTLPRI | Lowest priority at which right-to-left rather than left-to-right execution.
SPCPRI | Priority for specials - start.
FINPRI | Priority for finals.

Definition at line 160 of file FuncExprData.h.

## Constructor & Destructor Documentation

## FuncExprData()

casacore::FuncExprData::FuncExprData | ( |  | ) |

Construct the data for the expression analysis.

## ~FuncExprData()

casacore::FuncExprData::~FuncExprData | ( |  | ) |

inline

Destructor.

Definition at line 210 of file FuncExprData.h.

## Member Function Documentation

## binary1() [1/2]

map< String, ExprOperator > & casacore::FuncExprData::binary1 | ( |  | ) |

inline

Definition at line 221 of file FuncExprData.h.

References bin1_p.

## binary1() [2/2]

const map< String, ExprOperator > & casacore::FuncExprData::binary1 | ( |  | ) | const

inline

Definition at line 222 of file FuncExprData.h.

References bin1_p.

## binary2() [1/2]

map< String, ExprOperator > & casacore::FuncExprData::binary2 | ( |  | ) |

inline

Definition at line 219 of file FuncExprData.h.

References bin2_p.

## binary2() [2/2]

const map< String, ExprOperator > & casacore::FuncExprData::binary2 | ( |  | ) | const

inline

Definition at line 220 of file FuncExprData.h.

References bin2_p.

## function() [1/2]

map< String, ExprOperator > & casacore::FuncExprData::function | ( |  | ) |

inline

Definition at line 225 of file FuncExprData.h.

References func_p.

## function() [2/2]

const map< String, ExprOperator > & casacore::FuncExprData::function | ( |  | ) | const

inline

Definition at line 226 of file FuncExprData.h.

References func_p.

## print() [1/2]

void casacore::FuncExprData::print | ( | ostream & | os,
|  | const FuncExprData::ExprOperator & | pos ) const

Print an operation.

## print() [2/2]

void casacore::FuncExprData::print | ( | ostream & | os,
|  | const map< String, FuncExprData::ExprOperator > & | m ) const

Print an operator map.

## special() [1/2]

map< String, ExprOperator > & casacore::FuncExprData::special | ( |  | ) |

inline

Definition at line 223 of file FuncExprData.h.

References spop_p.

## special() [2/2]

const map< String, ExprOperator > & casacore::FuncExprData::special | ( |  | ) | const

inline

Definition at line 224 of file FuncExprData.h.

References spop_p.

## unary1() [1/2]

map< String, ExprOperator > & casacore::FuncExprData::unary1 | ( |  | ) |

inline

Definition at line 217 of file FuncExprData.h.

References una1_p.

## unary1() [2/2]

const map< String, ExprOperator > & casacore::FuncExprData::unary1 | ( |  | ) | const

inline

Definition at line 218 of file FuncExprData.h.

References una1_p.

## unary2() [1/2]

map< String, ExprOperator > & casacore::FuncExprData::unary2 | ( |  | ) |

inline

Accessors of the various maps.

Definition at line 215 of file FuncExprData.h.

References una2_p.

## unary2() [2/2]

const map< String, ExprOperator > & casacore::FuncExprData::unary2 | ( |  | ) | const

inline

Definition at line 216 of file FuncExprData.h.

References una2_p.

## Member Data Documentation

## allop_p

map<opTypes, ExprOperator> casacore::FuncExprData::allop_p

private

All operators.

Definition at line 249 of file FuncExprData.h.

## bin1_p

map<String, ExprOperator> casacore::FuncExprData::bin1_p

private

Binary operators of 1 character.

Definition at line 243 of file FuncExprData.h.

Referenced by binary1(), and binary1().

## bin2_p

map<String, ExprOperator> casacore::FuncExprData::bin2_p

private

Binary operators of 2 characters.

Definition at line 241 of file FuncExprData.h.

Referenced by binary2(), and binary2().

## func_p

map<String, ExprOperator> casacore::FuncExprData::func_p

private

Function names.

Definition at line 247 of file FuncExprData.h.

Referenced by function(), and function().

## spop_p

map<String, ExprOperator> casacore::FuncExprData::spop_p

private

Special operators.

Definition at line 245 of file FuncExprData.h.

Referenced by special(), and special().

## una1_p

map<String, ExprOperator> casacore::FuncExprData::una1_p

private

Unary operators of 1 character.

Definition at line 239 of file FuncExprData.h.

Referenced by unary1(), and unary1().

## una2_p

map<String, ExprOperator> casacore::FuncExprData::una2_p

private

Unary operators of 2 characters.

Definition at line 237 of file FuncExprData.h.

Referenced by unary2(), and unary2().

The documentation for this class was generated from the following file:

- scimath/Functionals/FuncExprData.h